* Printer control utility display filter packets                 11-Feb-2000

* These packets are used withthe ic_print_stat builtin fuction
*
*   CALL "ic_print_stat" [USING packet-1, ..., packet-n]
*
* where packet-i may be the name of any of the packets described
* below.
*
* If no packets are specified, the Printer Control Utility is
* started and uses either no filtering or a default filter specified
* with the ICPCQFILTER environment variable.
*
* If any packets are specified then only those files which meet the
* specified criterion will be displayed.  If more than one of these
* items is specified, then only files which meet ALL of the specified
* criteria will be displayed.  No more than 10 packets may be specified,
* and except for PCQ-FILTER-NULL each packet may be specified at most
* one time.
*
* The format of each packet is shown below.  Note that each packet has
* a common header format that varies only by the value of the packet
* identifier (and possibly rev at some later date).
*
* Revision History:
*       02/11/00     ic2.62     Added support for directory name filter


* No filtering
01 PCQ-FILTER-NULL.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE ZERO.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.

* Filter by range of PCQ numbers
01 PCQ-FILTER-QUEUE.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 1.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 QUEUE-PKT-MIN-PCQ         PIC 9(4) COMP.
   03 QUEUE-PKT-MAX-PCQ         PIC 9(4) COMP.

* Filter by range file sizes
01 PCQ-FILTER-SIZE.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 2.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 SIZE-PKT-MIN-SIZE         PIC 9(8) COMP.
   03 SIZE-PKT-MAX-SIZE         PIC 9(8) COMP.

* Filter by range of owners' console numbers (MS-DOS, AOS/VS) or user-ids (UNIX)
01 PCQ-FILTER-OWNER-ID.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 3.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 OWNER-ID-PKT-MIN-ID       PIC 9(4) COMP.
   03 OWNER-ID-PKT-MAX-ID       PIC 9(4) COMP.

* Filter by range of printed-by users' console numbers (MS-DOS, AOS/VS) or
* user-ids (UNIX)
01 PCQ-FILTER-PRINT-ID.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 4.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 PRINT-ID-PKT-MIN-ID       PIC 9(4) COMP.
   03 PRINT-ID-PKT-MAX-ID       PIC 9(4) COMP.

* Filter by owner's user name
01 PCQ-FILTER-OWNER-NAME.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 5.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 OWNER-NAME-PKT-NAME       PIC X(16).

* Filter by printed-by user name
01 PCQ-FILTER-PRINT-NAME.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 6.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 PRINT-NAME-PKT-NAME       PIC X(16).

* Filter by simple filename
01 PCQ-FILTER-FILE-NAME.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 7.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 FILE-NAME-PKT-NAME        PIC X(64).

* Filter by READ access to file
01 PCQ-FILTER-READ-ACCESS.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 8.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.

* Filter by status (mode); values for status field are defined below
01 PCQ-FILTER-STATUS.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 9.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 STATUS-PKT-STATUS         PIC 9(4) COMP.
   03 FILLER                    PIC 9(4) COMP VALUE ZERO.

* Filter by directory name
01 PCQ-FILTER-DIR-NAME.
   03 PCQ-FILTER-HEADER.
      05 PKT-ID                 PIC 9(2) COMP VALUE 10.
      05 PKT-REV                PIC 9(2) COMP VALUE ZERO.
      05 FILLER                 PIC 9(4) COMP VALUE ZERO.
   03 DIR-NAME-PKT-NAME         PIC X(64).


*  Values for STATUS-PKT-STATUS
01 FILLER.
*  No status
   03 PCQ-STATUS-NULL           PIC 9(2) COMP VALUE ZERO.
*  Not yet printed
   03 PCQ-STATUS-NEW            PIC 9(2) COMP VALUE 1.
*  Already printed
   03 PCQ-STATUS-OLD            PIC 9(2) COMP VALUE 2.
*  Error has occurred
   03 PCQ-STATUS-ERROR          PIC 9(2) COMP VALUE 3.
*  Update in progress
   03 PCQ-STATUS-OPEN           PIC 9(2) COMP VALUE 4.
*  Queued to print
   03 PCQ-STATUS-QUEUE          PIC 9(2) COMP VALUE 5.
*  Holding in the print queue
   03 PCQ-STATUS-HOLD           PIC 9(2) COMP VALUE 6.
*  Printing
   03 PCQ-STATUS-PRINT          PIC 9(2) COMP VALUE 7.
*  Retrying
   03 PCQ-STATUS-RETRY          PIC 9(2) COMP VALUE 8.
*  Terminating
   03 PCQ-STATUS-TERM           PIC 9(2) COMP VALUE 9.
